#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>
#include <ctime>
#include <cassert>
#include <cstdio>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#define fr first
#define sc second
#define mp make_pair
#define pb push_back
#define epr(...) fprintf(stderr, __VA_ARGS__)
#define db(x) cerr << #x << " = " << x << endl
#define db2(x, y) cerr << "(" << #x << ", " << #y << ") = (" << x << ", " << y << ")\n"; 
#define db3(x, y, z) cerr << "(" << #x << ", " << #y << ", " << #z << ") = (" << x << ", " << y << ", " << z << ")\n"
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()

#define equal equalll
#define less lesss
typedef long long ll;
const int N = 202;
const long long INF = 1e9 + 19;
const int dx[4] = {1, 0, -1, 0};
const int dy[4] = {0, 1, 0, -1};
const int gg[4] = {'D', 'R', 'U', 'L'};


int n, m, k;
char s[N][N];
char text[N];
//vector<int> e[N * N * N];
int color[N * N * N];
vector<int> st;
bool found = 0;
vector<int> cycle;

int code(int i, int j, int t) {
    int pos = i * m + j;
    return t * n * m + pos;
}

void decode(int pos, int &i, int &j) {
    i = pos / m;
    j = pos % m;
}
bool check(int x, int y) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

void dfs(int v) {
    //db(v);
    st.pb(v);
    color[v] = 1;

    int t = v / (n * m);
    int i, j;
    decode(v % (n * m), i, j);
    //db3(i, j, v);

    for (int dir = 0; dir < 4; dir++) {
        int x = i + dx[dir];
        int y = j + dy[dir];
        if (check(x, y) && s[x][y] == text[(t + 1) % k]) {
            int u = code(x, y, (t + 1) % k);
            //db2(v, u);
            if (color[u] == 0) {
                dfs(u);
                if (found) return;
            }
            else if (color[u] == 1) {
                for (int i = (int)st.size() - 1; st[i] != u; i--)
                    cycle.pb(st[i]);
                cycle.pb(u);
                found = 1;
                return;
            }
        }
    }
    st.pop_back();
    color[v] = 2;
}





void read() {
    //db("here");
    scanf("%d%d%d", &n, &m, &k);
    for (int i = 0; i < n; i++)
        scanf("%s", s[i]);
    scanf("%s", text);
}

void solve() {
    //db("tut");
    /*for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            for (int t = 0; t < k; t++) {
                if (text[t] != s[i][j])
                    continue;

                for (int dir = 0; dir < 4; dir++) {
                    int x = i + dx[dir];
                    int y = j + dy[dir];
                    if (check(x, y) && s[x][y] == text[(t + 1) % k])
                        e[code(i, j, t)].pb(code(x, y, (t + 1) % k));
                }
            }*/




    int all = n * m * k; 
    found = 0;
    //db(all);
    for (int i = 0; i < all; i++)
        if (color[i] == 0) {
            assert(st.empty());
            dfs(i);
            if (found) 
                break;
            //exit(0);
                
        }
    if (found) {
        puts("YES");
        reverse(all(cycle));
        int pos = 0;
        for (int i = 0; i < (int)cycle.size(); i++)
           if (cycle[i] < cycle[pos]) {
               pos = i;
           } 
        rotate(cycle.begin(), cycle.begin() + pos, cycle.end());
        int x, y;
        assert(cycle[0] < n * m);
        decode(cycle[0], x, y);
        printf("%d\n", (int)cycle.size());
        printf("%d %d\n", x + 1, y + 1);
        for (int i = 0; i < (int)cycle.size(); i++)  {
            int p1 = cycle[i] % (n * m);
            int p2 = cycle[(i + 1) % cycle.size()] % (n * m);
            int x1, y1, x2, y2;
            decode(p1, x1, y1);
            decode(p2, x2, y2);
            char ch = 0;
            for (int dir = 0; dir < 4; dir++) {
                if (x1 + dx[dir] == x2 && y1 + dy[dir] == y2) {
                    ch = gg[dir];
                }
            }
            assert(ch != 0);
            printf("%c", ch);
        }
        puts("");
    }
    else {
        puts("NO");
    }




}

void stress() {

}


int main(){
    //db("GGGG");
#ifdef MY_DEBUG
    freopen("in", "r", stdin);
    //freopen("out", "w", stdout);
#endif
    if (1) {
        int k = 1;
        for (int tt = 0; tt < k; tt++) {
            read();
            solve();
        }
    }
    else {
        stress();
    }

    return 0;
}


