# Usage examples:
# python3 gen_simple.py n=1000 k=10
# python3 gen_simple.py n=100,200 k=50 v=50
# python3 gen_simple.py n=5000 k=1000,2000 v=10,20
import random
from sys import argv, stderr

random.seed(" ".join(argv), 2)

n = (1, 5000)
k = (0, 1000000000)
v = (1, 1000000000)

for s in argv[1:]:
	if '=' in s:
		if s[:s.find('=')] in ("n", "k", "v"):
			exec(s)
		else:
			print("Wrong argument", s, file=stderr)

if type(n) != int:
	n = random.randint(n[0], n[1])
if type(k) != int:
	k = random.randint(k[0], k[1])
if type(v) == int:
	v = (1, v)

print(n, k)
print(" ".join(str(random.randint(v[0], v[1])) for i in range(n)))
