#include <bits/stdc++.h>

const int maxn = 400;

void readMatrix(int &n, int &m, std::vector<std::vector<char>> &matrix) {
  scanf("%d%d", &n, &m);
  matrix.resize(n);
  char s[maxn];
  for (int i = 0; i < n; i++) {
    scanf("%s", s);
    matrix[i].resize(m);
    for (int j = 0; j < m; j++) {
      matrix[i][j] = s[j];
    }
  }
}

int main() {
  int nDetail, mDetail;
  std::vector<std::vector<char>> detail;
  readMatrix(nDetail, mDetail, detail);
  int nMold, mMold;
  std::vector<std::vector<char>> mold;
  readMatrix(nMold, mMold, mold);
  std::set<std::pair<int, int>> used;
  for (int i = 0; i < nMold; i++) {
    for (int j = 0; j < mMold; j++) {
      if (mold[i][j] == '#') {
        used.emplace(nMold - i - 1, j);
      }
    }
  }
  std::vector<std::pair<int, int>> dcoords;
  for (int i = 0; i < nDetail; i++) {
    for (int j = 0; j < mDetail; j++) {
      if (detail[i][j] == '*') {
        dcoords.emplace_back(nDetail - i - 1, j);
      }
    }
  }
  int answer = 0;
  for (int shift = -mDetail + 1; shift <= mMold; shift++) {
    std::vector<std::pair<int, int>> ds(dcoords.size());
    for (size_t i = 0; i < ds.size(); i++) {
      ds[i] = {dcoords[i].first + nMold, dcoords[i].second + shift};
    }
    while (true) {
      bool intersected = false;
      bool allDown = true;
      for (const auto& cs : ds) {
        allDown &= cs.first < 0;
        if (used.count(cs)) {
          intersected = true;
          break;
        }
      }
      if (allDown) {
        break;
      }
      if (intersected) {
        int hitches = 0;
        for (auto &cs : ds) {
          cs.first++;
          hitches += used.count({cs.first, cs.second - 1});
        }
        answer = std::max(answer, hitches);
        break;
      }
      for (auto &cs : ds) {
        cs.first--;
      }
    }
  }
  printf("%d\n", answer);
  return 0;
}