#include <cstdio>
#include <algorithm>
using namespace std;

const int A = 200;
int dx[4] = {1, -1, 0, 0};
int dy[4] = {0, 0, 1, -1};
char dc[4] = {'D', 'U', 'R', 'L'};

int n, m, l;
char s[A + 1];
char a[A][A + 1];
int col[A][A][A];
int gd[A][A][A];
char st[A * A * A + 1];
int stx[A * A * A];
int sty[A * A * A];
int stp = 0;

int dfs(int i, int j, int d, int cgd) {
    if (col[i][j][d] == 1) {
        return gd[i][j][d];
    }
    if (col[i][j][d] != 0) {
        return -1;
    }
    stx[stp] = i;
    sty[stp] = j;
    gd[i][j][d] = cgd;
    col[i][j][d] = 1;
    int nd = d + 1 == l ? 0 : d + 1;
    for (int t = 0; t < 4; t++) {
        int x = i + dx[t];
        int y = j + dy[t];
        if (x < 0 || x >= n || y < 0 || y >= m || a[x][y] != s[nd]) {
            continue;
        }
        st[stp++] = dc[t];
        int r = dfs(x, y, nd, cgd + 1);
        if (r != -1) {
            return r;
        }
        --stp;
    }
    col[i][j][d] = 2;
    return -1;
}

int main() {
    scanf("%d%d%d", &n, &m, &l);
    for (int i = 0; i < n; i++) {
        scanf("\n%s", a[i]);
    }
    scanf("\n%s", s);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == s[0] && col[i][j][0] == 0) {
                int r = dfs(i, j, 0, 0);
                if (r != -1) {
                    printf("YES\n");
                    int rot = (l - r % l) % l;
                    rotate(st + r, st + r + rot, st + stp);
                    printf("%d\n%d %d\n", stp - r, stx[r + rot] + 1, sty[r + rot] + 1);
                    st[stp] = 0;
                    printf("%s", st + r);
                    return 0;
                }
            }
        }
    }

    printf("NO");

    return 0;
}